 // PokeMod! - the world of pokemon in CS
 
 /*
 Credits
	- Onix					- used sprites, sounds, and launchnade and do_victim code from yang's Veronika hero
	- Diglet				- used positionChangeCheck code from scoutPractice / JTP10181 's Blink hero
							- used PassAimTest code from sharky/JTP10181 's Batgirl hero
	- Sounds				- used some sounds from FFX mod
	- PokeLoop				- used loop code from {HOJ} Batman/JTP10181 's Captain America hero
	- fullupdate Blocker	- used JTP10181's fullupdate Blocker
	- NPCS					- used Twilight Suzuka's NPC guide thing
							- used mole code from WC3FT mod
	- Item Drops			- used a lot of stuff from the looting plugin
	- Custom Game Name		- used NeuroToxin92's Game Name Changer

 //--CVARS--//
 pm_pokemod 1		//turns pokemod on and off (1=on, 0=off)
 pm_botsays 1		//turns on bot radio commands when they choose/buy a pokemon/item
 pm_time 10.0		//cooldown time for some skills (Bulbasaur, Geodude, Onix, Diglet, Starmie, Poliwhirl, Togepi)

 //Ash
 pm_rage 5			//1 extra damage for this ammount of hp
 pm_bubbledamage 25	//damage of bubble beam
 pm_bubblenum 10	//number of bubble beams each round and after charged
 pm_leech 5			//ammount of hp to leech every 5 secs if target is being leeched

 //Brock
 pm_harden 1		//how much hp he gets per armor
 pm_rockthrow 100	//max damage of getting hit by a boulder, if your hit by the boulder then it does this ammount

 //Team-Rocket
 pm_poison 5		//damage of poison attacks (weezing and arbok)
 */

 #include <amxmodx>
 #include <cstrike>
 #include <engine>
 #include <fakemeta>
 #include <fun>

 #define PLUGNAME		"PokeMod"
 #define AUTHOR			"Emp`"
 new const VERSION[] =	"1.0"

 //--Keys for menu to keep it organized--//
 #define KEY_1      (1<<0)
 #define KEY_2      (1<<1)
 #define KEY_3      (1<<2)
 #define KEY_4      (1<<3)
 #define KEY_5      (1<<4)
 #define KEY_6      (1<<5)
 #define KEY_7      (1<<6)
 #define KEY_8      (1<<7)
 #define KEY_9      (1<<8)
 #define KEY_0      (1<<9)

 new origin[33][3]			//different players origins
 new BindUsed[33]			//this is used to have delays between pokemon skill uses
 new save[33]				//allows a player to not have to pick a pokemon next round
 new bool:g_hasSelected[33]	//whether someone as a pokemon already
 new maxhp[33]				//this is a players maxhp for pokemod
 new bool:g_isHealing[33]	//when someone is using the pokecenter to heal

 //--NPC stuff--//
 new spawnEntString[2][] = {"info_player_start","info_player_deathmatch"}
 new bool:spawnPointsused[33] = false
 new PCent[3]
 
 //--Ash stuff--//
 new bool:g_hasCharmander[33]
 new bool:g_hasSquirtle[33]
 new bool:g_hasBulbasaur[33]
 new bool:g_hasPikachu[33]
 new bool:g_isLeeched[33]
 new bool:g_isSearching[33]
 new bubbles[33]
 new rage[33]
 new rope
 new count[33]
 new bubble
 
 //--Brock stuff--//
 new bool:g_hasGeodude[33]
 new bool:g_hasOnix[33]
 new bool:g_hasDiglet[33]
 new bool:g_isDigging[33]
 new xplode
 new aim[33][3]
 new g_lastPosition[33][3]
 new checkCount[33]
 new ctime[33]
 
 //--Misty stuff--//
 new bool:g_hasStarmie[33]
 new bool:g_hasPoliwhirl[33]
 new bool:g_hasTogepi[33]
 
 //--Team-Rocket stuff--//
 new bool:g_hasArbok[33]
 new bool:g_hasWeezing[33]
 new bool:g_hasMeowth[33]
 new bool:g_isPoisoned[33]
 new arbok
 new gas
 new cpois[33]
 
 //--Ghost Pokemon stuff--//
 new bool:g_hasGastly[33]
 new bool:g_hasHaunter[33]
 new bool:g_hasGengar[33] 
 new gtime
 new bool:g_isAsleep[33]

 //--Items--//
 new bool:g_hasPotion[33]
 new bool:g_hasAntidote[33]
 new bool:g_hasEscapeRope[33] 
 new bool:g_hasFullHeal[33]
 new bool:g_hasSuperPotion[33]
 new bool:g_hasHyperPotion[33] 
 new bool:g_hasFullRestore[33]
 new bool:g_hasBicycle[33]
 new bool:g_hasHPUp[33]
 new bool:g_hasNoItems[33]
 new pokeball
 new iorigin[33][3]

 new Item[9][33]		//allows a player to have multiple of an item
 new CostArray[9] = {	//costs for items in pokemart
	300,
	100,
	550,
	600,
	700,
	1500,
	3000,
	5000,
	9800
 }

 //--Starts plugin--//
 public plugin_init()
 {
	register_plugin(PLUGNAME, VERSION, AUTHOR)
	
	//Thanks to SuperHeroMod
	register_cvar("PokeMod_Version",VERSION,FCVAR_SERVER|FCVAR_SPONLY)
	set_cvar_string("PokeMod_Version",VERSION)
	
	//The different menus
	register_menucmd(register_menuid("\rAsh's Pokemon:"),1023,"AshChoices")
	register_menucmd(register_menuid("\rBrock's Pokemon:"),1023,"BrockChoices")
	register_menucmd(register_menuid("\rMisty's Pokemon:"),1023,"MistyChoices")
	register_menucmd(register_menuid("\rTeam-Rocket's Pokemon:"),1023,"TRChoices")
	register_menucmd(register_menuid("\rGhost Pokemon:"),1023,"GhostChoices")
	register_menucmd(register_menuid("\rPokeBall Categories:"),1023,"TeamChoices")
	register_menucmd(register_menuid("\rPoke Mart:"),1023,"ShopChoices")
	register_menucmd(register_menuid("\rPoke Center:"),1023,"MenuChoices")

	//Base PokeMod Cvars
	register_cvar("pm_pokemod","1")
	register_cvar("pm_botsays","1")
	register_cvar("pm_time","10.0")

	//Ashs Pokemon Cvars
	register_cvar("pm_rage","5")
	register_cvar("pm_bubbledamage","25")
	register_cvar("pm_bubblenum","10")
	register_cvar("pm_leech","5")

	//Brocks Pokemon Cvars
	register_cvar("pm_harden","1")
	register_cvar("pm_rockthrow","100")

	//TeamRockets Pokemon Cvars
	register_cvar("pm_poison","5")

	//Events, Loop, and other
	register_event("Damage", "pokemon_damage", "b", "2!0")
	register_event("ResetHUD", "new_spawn", "b")
	register_event("DeathMsg", "pokemon_death", "a")
	set_task(1.0, "pokemon_loop", 0, "", 0, "b")
	register_forward( FM_GetGameDescription, "GameDesc" ); 
  
	//Available Client Say Commands
	register_clcmd("say","ClientSays")

	//Client Console commands
	register_clcmd("pokeskill","keydown",ADMIN_ALL, "- uses pokemon bind skill")
	register_clcmd("pokeitem","UseItem",ADMIN_ALL, "- uses PokeItem")
	register_clcmd("fullupdate","fullupdate")	//this just blocks the fullupdate abuse
 }
 
 //--Game Name Changer--//
 public GameDesc( )
 { 
	new gamename[32]; 
	gamename = "Counter-Strike PokeMod"
	forward_return( FMV_STRING, gamename ); 
	return FMRES_SUPERCEDE; 
 }
 
 //--Precached Items--//
 public plugin_precache()
 {
	//Only Custom Pokemon files need to be downloaded

	//Precached Sounds
	precache_sound("hornet/ag_hornethit1.wav")
	precache_sound("turret/tu_ping.wav")
	precache_sound("turret/tu_fire1.wav")
	precache_sound("common/bodydrop1.wav")
	//Custom Pokemon Sounds
	precache_sound("pokemon/pokecenter.wav")
	precache_sound("pokemon/a_exm2.wav")
	precache_sound("pokemon/noisy.wav")
	precache_sound("pokemon/cure.wav")
	precache_sound("pokemon/cast.wav")

	//Precached Sprites
	rope = 		precache_model("sprites/rope.spr")
	bubble = 	precache_model("sprites/bubble.spr")
	gas = 		precache_model("sprites/poison.spr")
	//Custom Pokemon Sprites
	pokeball =	precache_model("sprites/pokemon/pokeball.spr")
	xplode = 	precache_model("sprites/pokemon/zerogxplode2.spr")
	arbok = 	precache_model("sprites/pokemon/arbok.spr")

	//Precached Models
	precache_model("models/big_rock.mdl")
	//Custom Pokemon Models
	precache_model("models/pokemon/oak.mdl")
	precache_model("models/pokemon/oakT.mdl")
 }

 //--Every time someone disconnects, you have to get rid of their items--//
 public client_disconnect(id)
 {
	while(find_ent_by_class(-1,"item") != 0) remove_entity(find_ent_by_class(-1,"item"))
	if(task_exists(3331+id)) remove_task(3331+id)
	
	return PLUGIN_CONTINUE
 }

 //--Every ResetHUD--//
 public new_spawn(id)
 {
	//Remove Items
	if(find_ent_by_owner(-1,"item",id)!=0){
		remove_entity(find_ent_by_owner(-1,"item",id))
		NoItems(id)
		}
	if(task_exists(3331+id)) remove_task(3331+id)

	//Remove old npcs
	if(is_valid_ent(PCent[1])) remove_entity(PCent[1])
	if(is_valid_ent(PCent[2])) remove_entity(PCent[2])

	if(get_cvar_num("pm_pokemod")!=1) return

	//Make all spawn points possible again
	for(new i=0 ; i < 33 ; i++){
		spawnPointsused[i] = false
	}
	
	//Make new npcs
	npc_pokecenter(1)
	npc_pokecenter(2)
	
	//Auto Things for bots

	if(is_user_bot(id)){
		new Float:dist

		dist = Float:entity_range(id,PCent[1])
		if(dist>200) dist = Float:entity_range(id,PCent[2])
	
		if(dist<201){
			BotCenter(id)
		}
	}

	//Do other stuff such as setting hp and removing pokemon statuses and pokemon
	
	if(maxhp[id] > 100) set_user_health(id, maxhp[id])
	if(maxhp[id] <= 100) maxhp[id] = 100

	if(!g_hasPotion[id] && !g_hasAntidote[id] && !g_hasEscapeRope[id] && !g_hasFullHeal[id] && !g_hasSuperPotion[id] && !g_hasHyperPotion[id] && !g_hasFullRestore[id] && !g_hasBicycle[id] && !g_hasHPUp[id])
		g_hasNoItems[id] = true

	if(!save[id]){ //resets not having pokemon
	g_hasSelected[id] = false

	g_hasCharmander[id] = false
	g_hasSquirtle[id] = false
	g_hasBulbasaur[id] = false
	g_hasPikachu[id] = false

	g_hasGeodude[id] = false
	g_hasOnix[id] = false
	g_hasDiglet[id] = false

	g_hasStarmie[id] = false
	g_hasPoliwhirl[id] = false
	g_hasTogepi[id] = false

	g_hasArbok[id] = false
	g_hasWeezing[id] = false
	g_hasMeowth[id] = false

	g_hasGastly[id] = false
	g_hasHaunter[id] = false
	g_hasGengar[id] = false
	}

	g_isLeeched[id] = false
	g_isSearching[id] = false
	g_isDigging[id] = false

	set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
	bubbles[id] = get_cvar_num("pm_bubblenum")
	rage[id] = 0
	count[id] = 20*get_cvar_num("pm_time")
	ctime[id] = 70
	g_isPoisoned[id] = false
	g_isAsleep[id] = false
	g_isHealing[id] = false
	screenflash(id,0,0,0,0)

	BindUsed[id] = false
 }
 
 //--When someone dies--//
 public pokemon_death()
 {
	if(get_cvar_num("pm_pokemod")!=1) return

	new id = read_data(2)

 	maxhp[id] = 100
	g_isPoisoned[id] = false
	screenflash(id, 0, 0, 0, 0)
	g_isLeeched[id] = false
	g_isDigging[id] = false
	g_isSearching[id] = false
	g_isAsleep[id] = false
	g_isHealing[id] = false

	if(g_hasNoItems[id]) return

   	get_user_origin(id,iorigin[id],0)

	new parm[1]
   	parm[0] = id
   	set_task(1.2,"item_sprite",3331+id,parm,1,"b")

	new Float:origina[3]
	new mark = create_entity("info_target")
	entity_set_string(mark,EV_SZ_classname,"item")
	entity_set_int(mark,EV_INT_solid,1)

	origina[0] = float(iorigin[id][0])
	origina[1] = float(iorigin[id][1])
	origina[2] = float(iorigin[id][2])

	entity_set_origin(mark,origina)
	entity_set_float(mark,EV_FL_scale,0.2)
	entity_set_edict(mark,EV_ENT_owner,id)
 }

 //--Moves NPCS--//
 public fullupdate(id)
 {
 	if(get_cvar_num("pm_pokemod")!=1 || !is_user_alive(id)) return PLUGIN_HANDLED

	new team

	if(get_user_team(id)==1) team = 1
	else if(get_user_team(id)==2) team = 2

	//Remove old npc
	if(is_valid_ent(PCent[team])) remove_entity(PCent[team])


	//Make all spawn points possible again
	for(new i=0 ; i < 33 ; i++){
		spawnPointsused[i] = false
	}
	
	//Make new npc
	npc_pokecenter(team)

	return PLUGIN_HANDLED
 }
 
 //--When someone press pokemenu--//
 public keydown(id)
 {
	if(!is_user_alive(id) || get_cvar_num("pm_pokemod")!=1) return PLUGIN_HANDLED
	
	if(!g_hasSelected[id]) TeamMenu(id)
	else if (g_hasSquirtle[id] && !BindUsed[id]) Squirtle_keydown(id, 0)
	else if (g_hasBulbasaur[id] && !BindUsed[id] && !g_isSearching[id]) Bulbasaur_keydown(id, 0)
	else if (g_hasGeodude[id] && !BindUsed[id]) Geodude_keydown(id, 0)
	else if (g_hasOnix[id] && !BindUsed[id]) Onix_keydown(id, 0)
	else if (g_hasDiglet[id] && !BindUsed[id]) Diglet_keydown(id, 0)
	else if (g_hasStarmie[id] && !BindUsed[id]) Starmie_keydown(id, 0)
	else if (g_hasPoliwhirl[id] && !BindUsed[id]) Poliwhirl_keydown(id, 0)
	else if (g_hasTogepi[id] && !BindUsed[id]) Togepi_keydown(id)
	else if (g_hasHaunter[id] && !BindUsed[id]) Haunter_keydown(id,0)
	else sounddeny(id)

	return PLUGIN_HANDLED
 }
 
 //--When a client says something--//
 public ClientSays(id)
 {
	new said[192]
	read_args(said,191)
	remove_quotes(said)

	if ( equali(said,"/pokemonhelp") || equali(said,"pokemonhelp") || equali(said,"/pokemodhelp") || equali(said,"pokemodhelp") || equali(said,"/help") || equali(said,"help") || equali(said,"/pokehelp") || equali(said,"pokehelp") ) {
		pokehelp(id)
		return PLUGIN_CONTINUE
	}
	else if ( equali(said,"/pokedex") || equali(said,"pokedex") || equali(said,"/skills") || equali(said,"skills") || equali(said,"pokeskills") || equali(said,"/pokeskills") ) {
		pokedex(id)
		return PLUGIN_CONTINUE
	}
	else if((containi(said, "pokemod") != -1) || (containi(said, "pokemon") != -1) || (containi(said, "/pokemod") != -1) || (containi(said, "/pokemon") != -1)) {
		client_print(id,print_chat, "[PokeMod] For help with PokeMod, say: /help")
		return PLUGIN_CONTINUE
	}
	else if((containi(said, "save") != -1) || (containi(said, "/save") != -1) || (containi(said, "unsave") != -1) || (containi(said, "/unsave") != -1)) {
		savepokemon(id)
		return PLUGIN_CONTINUE
	}
	else if((containi(said, "dropitem") != -1) || (containi(said, "dropitems") != -1)  || (containi(said, "/dropitem") != -1)  || (containi(said, "/dropitems") != -1) ) {
		NoItems(id)
		return PLUGIN_CONTINUE
	}
	else if((containi(said, "movenpc") != -1) || (containi(said, "/movenpc") != -1) ) {
		fullupdate(id)
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
 }
 
 //--When someone wants to look at the pokehelp file--//
 public pokehelp(id)
 {
	show_motd(id,"pokehelp.txt","PokeMod Info")
	return PLUGIN_HANDLED
 }
 
 //--When someone wants to look at the pokedex file--//
 public pokedex(id)
 {
	show_motd(id,"pokedex.txt","Pokemon Info")
	return PLUGIN_HANDLED
 }
 
 //--AshMenu--//
 public AshMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rAsh's Pokemon:^n^n \w1.  \yCharmander\R\wRage^n 2.  \ySquirtle\R\wBubble Beam^n 3.  \yBulbasaur\R\wLeech Seed^n 4.  \yPikachu\R\wQuick Attack^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_4|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public AshChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasSelected[id] = true
			g_hasCharmander[id] = true
			screenflash(id, 255, 0, 0, 50)
			client_print(id, print_chat, "[PokeMod] You now have charmander's rage! Do more damage after being hit!")
		}
		case 1:
		{
			g_hasSelected[id] = true
			g_hasSquirtle[id] = true
			screenflash(id, 0, 0, 255, 50)
			client_print(id, print_chat, "[PokeMod] You now have squirtle's bubble beam! Go into water to recharge it!")
		}
		case 2:
		{
			g_hasSelected[id] = true
			g_hasBulbasaur[id] = true
			screenflash(id, 0, 255, 0, 50)
			client_print(id, print_chat, "[PokeMod] You now have bulbasaur's leech seed! Slowly drain someone's HP!")
		}
		case 3:
		{
			g_hasSelected[id] = true
			g_hasPikachu[id] = true
			screenflash(id, 250, 250, 10, 50)
			client_print(id, print_chat, "[PokeMod] You now have pikachu's quick attack! Do double damage!")
		}
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--BrockMenu--//
 public BrockMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rBrock's Pokemon:^n^n \w1.  \yGeodude\R\wHarden^n 2.  \yOnix\R\wRock Throw^n 3.  \yDiglet\R\wDig^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public BrockChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasSelected[id] = true
			g_hasGeodude[id] = true
			screenflash(id, 128, 128, 128, 50)
			client_print(id, print_chat, "[PokeMod] You now have geodude's harden! Keydown to swap half of you armor for health!")
		}
		case 1:
		{
			g_hasSelected[id] = true
			g_hasOnix[id] = true
			screenflash(id, 226, 226, 226, 50)
			client_print(id, print_chat, "[PokeMod] You now have onix's rock throw! Start throwing those boulders!")
		}
		case 2:
		{
			g_hasSelected[id] = true
			g_hasDiglet[id] = true
			screenflash(id, 139, 59, 19, 50)
			client_print(id, print_chat, "[PokeMod] You now have diglet's dig! Dig your way over to where your aiming!")
		}
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--MistyMenu--//
 public MistyMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rMisty's Pokemon:^n^n \w1.  \yStarmie\R\wRecover^n 2.  \yPoliwhirl\R\wConfusion^n 3.  \yTogepi\R\wMetronome^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public MistyChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasSelected[id] = true
			g_hasStarmie[id] = true
			screenflash(id, 128, 0, 128, 50)
			client_print(id, print_chat, "[PokeMod] You now have starmie's recover! Keydown to recieve health!")
		}
		case 1:
		{
			g_hasSelected[id] = true
			g_hasPoliwhirl[id] = true
			screenflash(id, 0, 0, 255, 50)
			client_print(id, print_chat, "[PokeMod] You now have poliwhirl's confusion! Keydown and enemies look the other way!")
		}
		case 2:
		{
			g_hasSelected[id] = true
			g_hasTogepi[id] = true
			screenflash(id, 248, 201, 74, 50)
			client_print(id, print_chat, "[PokeMod] You now have togepi's metronome! Keydown and use a random pokemon skill!")
		}
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--Team-RocketMenu--//
 public TRMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rTeam-Rocket's Pokemon:^n^n \w1.  \yArbok\R\wPoison Sting^n 2.  \yWeezing\R\wToxic^n 3.  \yMeowth\R\wScratch^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public TRChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasSelected[id] = true
			g_hasArbok[id] = true
			screenflash(id, 128, 0, 128, 50)
			client_print(id, print_chat, "[PokeMod] You now have arbok's poison sting! Poison attackers!")
		}
		case 1:
		{
			g_hasSelected[id] = true
			g_hasWeezing[id] = true
			screenflash(id, 128, 0, 128, 50)
			client_print(id, print_chat, "[PokeMod] You now have weezing's toxic! Leave toxic gases where you walk!")
		}
		case 2:
		{
			g_hasSelected[id] = true
			g_hasMeowth[id] = true
			screenflash(id, 248, 201, 74, 50)
			client_print(id, print_chat, "[PokeMod] You now have meowth's scratch! Make an attacker switch weapons!")
		}
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--GhostMenu--//
 public GhostMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rGhost Pokemon:^n^n \w1.  \yGastly\R\wNight Shade^n 2.  \yHaunter\R\wHypnosis/Dream Eater^n 3.  \yGengar\R\wConfuse Ray^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public GhostChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasSelected[id] = true
			g_hasGastly[id] = true
			screenflash(id, 28, 0, 28, 50)
			client_print(id, print_chat, "[PokeMod] You now have gastly's night shade! Fade in and out of sight!")
		}
		case 1:
		{
			g_hasSelected[id] = true
			g_hasHaunter[id] = true
			screenflash(id, 128, 0, 128, 50)
			client_print(id, print_chat, "[PokeMod] You now have haunter's hypnosis and dream eater! Make players sleep and eat their dreams!")
		}
		case 2:
		{
			g_hasSelected[id] = true
			g_hasGengar[id] = true
			screenflash(id, 108, 0, 108, 50)
			client_print(id, print_chat, "[PokeMod] You now have gengar's confuse ray! Randomly remove 2 hitzones!")
		}
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--TeamMenu--//
 public TeamMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rPokeBall Categories:^n^n\w1.  \yAsh's PokeBalls^n\w2.  \yBrock's PokeBalls^n\w3.  \yMisty's PokeBalls^n\w4.  \yTeam-Rocket's PokeBalls^n\w5.  \yGhost PokeBalls^n^n\w9.  Pokedex^n0.  Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_4|KEY_5|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public TeamChoices(id, key)
 {
	switch(key)
	{
		case 0: AshMenu(id)
		case 1: BrockMenu(id)
		case 2: MistyMenu(id)
		case 3: TRMenu(id)
		case 4: GhostMenu(id)
		case 8: pokedex(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--PokeMenu--//
 public PokeMenu(id)
 {
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rPoke Center:^n^n\w1.  PokeBalls^n2.  PokeMart^n3.  Heal^n4.  Save/Unsave Pokemon^n^n9.  PokeHelp^n0.  Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_4|KEY_9|KEY_0

		show_menu(id, key, menuBody)
 }
 public MenuChoices(id, key)
 {
	switch(key)
	{
		case 0: { if(!g_hasSelected[id]) TeamMenu(id)
				else client_print(id, print_chat,"[PokeMod] Sorry, but you already have a pokemon.")
		}
		case 1: ShopMenu(id)
		case 2: {
			if(g_hasBicycle[id]){
				client_print(id, print_chat,"[PokeMod] Sorry, but you can't be healed on a bicycle.")
				return PLUGIN_CONTINUE
			}
			emit_sound(id, CHAN_WEAPON, "pokemon/pokecenter.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			g_isHealing[id] = true
			set_user_maxspeed(id, 1.0)
			set_task(2.0,"finish_heal", id)
		}
		case 3: savepokemon(id)
		case 8: pokehelp(id)
		case 9: return PLUGIN_CONTINUE
	}
	return PLUGIN_HANDLED
 }
 //--ShopMenu--//
 public ShopMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rPoke Mart:^n^n\w1.  Potion\R300^n2.  Antidote\R100^n3.  Escape Rope\R550^n4.  Full Heal\R600^n5.  Super Potion\R700^n6.  Hyper Potion\R1500^n7.  Full Restore\R3000^n8.  Bicycle\R5000^n9.  HP Up\R9800^n0.  Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_4|KEY_5|KEY_6|KEY_7|KEY_8|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public ShopChoices(id, key)
 {
	switch(key)
	{
		case 9: return PLUGIN_CONTINUE
		default:{
			new parm[2]
			parm[0] = id
			if(BuyCheck(id,key)==1){
			if(key==0) parm[1] = 0
			else if(key==1) parm[1] = 1
			else if(key==2) parm[1] = 2
			else if(key==3) parm[1] = 3
			else if(key==4) parm[1] = 4
			else if(key==5) parm[1] = 5
			else if(key==6) parm[1] = 6
			else if(key==7) parm[1] = 7
			else if(key==8) parm[1] = 8
			set_task(0.1, "buy_item",1, parm, 2)
			}
		}
	}
	return PLUGIN_HANDLED
 }

 //--Stuff for the pokemart--//
 BuyCheck(id,key)
 {
	if(!is_user_alive(id) || get_cvar_num("pm_pokemod")!=1) return 0
	else if (g_hasNoItems[id]) return 1
	else if (g_hasPotion[id] && key==0) return 1
	else if (g_hasAntidote[id] && key==1) return 1
	else if (g_hasEscapeRope[id] && key==2) return 1
	else if (g_hasFullHeal[id] && key==3) return 1
	else if (g_hasSuperPotion[id] && key==4) return 1
	else if (g_hasHyperPotion[id] && key==5) return 1
	else if (g_hasFullRestore[id] && key==6) return 1
	else if (g_hasBicycle[id] && key==7) return 1
	else if (g_hasHPUp[id] && key==8) return 1
	else {
	client_print(id,print_chat,"[PokeMod] You can only have one type of an item at a time.")
	client_print(id,print_chat,"[PokeMod] Type /dropitem to drop your current item.")
	return 0
	}
	return PLUGIN_CONTINUE
 }

 //--Item Stuff--//
 public buy_item(parm[])
 {
	new cost, money, id = parm[0], num = parm[1], item[13]
	new random = random_num(1,100)

	if(!is_user_alive(id) || get_cvar_num("pm_pokemod")!=1) return PLUGIN_HANDLED

	if(num==0) item = "Potion"
	else if (num==1) item = "Antidote"
	else if (num==2) item = "Escape Rope"
	else if (num==3) item = "Full Heal"
	else if (num==4) item = "Super Potion"
	else if (num==5) item = "Hyper Potion"
	else if (num==6) item = "Full Restore"
	else if (num==7) item = "Bicycle"
	else if (num==8) item = "HP Up"
	
	cost = CostArray[num]
	money = cs_get_user_money(id)
	if(num==7 && g_hasBicycle[id]){
		client_print(id, print_chat,"[PokeMod] Sorry, but you can only have one bicycle.")
		return PLUGIN_HANDLED
	}
	if(money < cost){//costs too much
		client_print(id, print_chat,"[PokeMod] Sorry, but you don't have enough money.")
		return PLUGIN_HANDLED
	}
	if(random < 25){//out of stock
		client_print(id, print_chat,"[PokeMod] Sorry, but we don't have any %ss.", item)
		return PLUGIN_HANDLED
	}
	else if(24 < random < 76 || num==7 || money < 2*cost){//buyone
		if(is_user_bot(id)) BotSay(id, 1, 1, num)
		Item[num][id] += 1
		g_hasNoItems[id] = false
		cs_set_user_money(id, money - cost)
		client_print(id, print_chat,"[PokeMod] You bought one %s.", item)
	}
	else if(random > 75){//theres a deal
		if(random < 91 || money < 3*cost){//just normal deal 3 for price of 2
			if(is_user_bot(id)) BotSay(id, 1, 3, num)
			Item[num][id] += 3
			g_hasNoItems[id] = false
			cs_set_user_money(id, money - 2*cost)
			client_print(id, print_chat,"[PokeMod] You bought three %ss for the price of two!", item)
		}
		else{//super deal 5 for the price of 3
			if(is_user_bot(id)) BotSay(id, 1, 5, num)
			Item[num][id] += 5
			g_hasNoItems[id] = false
			cs_set_user_money(id, money - 3*cost)
			client_print(id, print_chat,"[PokeMod] You bought five %ss for the price of three!", item)
		}
	}
	if(random > 24){
		if(num==0) g_hasPotion[id] = true
		else if(num==1) g_hasAntidote[id] = true
		else if(num==2) g_hasEscapeRope[id] = true
		else if(num==3) g_hasFullHeal[id] = true
		else if(num==4) g_hasSuperPotion[id] = true
		else if(num==5) g_hasHyperPotion[id] = true
		else if(num==6) g_hasFullRestore[id] = true
		else if(num==7) g_hasBicycle[id] = true
		else if(num==8) g_hasHPUp[id] = true
		
		g_hasNoItems[id] = false
	}
	return PLUGIN_HANDLED
 }
 public UseItem(id)
 {
	if(!is_user_alive(id) || get_cvar_num("pm_pokemod")!=1) return PLUGIN_HANDLED

	if(g_hasNoItems[id]) ShopMenu(id)
	
	else if(g_hasPotion[id]){
		emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		Item[0][id] -= 1
		if(Item[0][id] == 0){
			g_hasPotion[id] = false
			g_hasNoItems[id] = true
		}
		if(get_user_health(id) <= maxhp[id] - 20) set_user_health(id, get_user_health(id) + 20)
		else set_user_health(id, maxhp[id])
		client_print(id,print_chat,"[PokeMod] You used a Potion!")
	}
	else if(g_hasAntidote[id]){
		if(g_isPoisoned[id]){
			emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			Item[1][id] -= 1
			g_isPoisoned[id] = false
			if(Item[1][id] == 0){
				g_hasAntidote[id] = false
				g_hasNoItems[id] = true
			}
			client_print(id,print_chat,"[PokeMod] You used an Antidote!")
			}
		else client_print(id,print_chat,"[PokeMod] You are not poisoned.")
	}
	else if(g_hasEscapeRope[id]){
		Item[2][id] -= 1
		EscapeRope(id)
		if(Item[2][id] == 0){
			g_hasEscapeRope[id] = false
			g_hasNoItems[id] = true
		}
		client_print(id,print_chat,"[PokeMod] You used an Escape Rope!")
	}	
	else if(g_hasFullHeal[id]){
		if(g_isPoisoned[id] || g_isAsleep[id] || g_isLeeched[id]){
			emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			Item[3][id] -= 1
			if(Item[3][id] == 0){
				g_hasFullHeal[id] = false
				g_hasNoItems[id] = true
			}
			g_isPoisoned[id] = false
			g_isAsleep[id] = false
			screenflash(id, 0, 0, 0, 0)
			g_isLeeched[id] = false
			client_print(id,print_chat,"[PokeMod] You used a Full Heal!")
			}
		else client_print(id,print_chat,"[PokeMod] You do not have any status effects.")
	}
	else if(g_hasSuperPotion[id]){
		emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		Item[4][id] -= 1
		if(Item[4][id] == 0){
			g_hasSuperPotion[id] = false
			g_hasNoItems[id] = true
		}
		if(get_user_health(id) <= maxhp[id] - 70) set_user_health(id, get_user_health(id) + 70)
		else set_user_health(id, maxhp[id])
		client_print(id,print_chat,"[PokeMod] You used a Super Potion!")
	}
	else if(g_hasHyperPotion[id]){
		emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		Item[5][id] -= 1
		if(Item[5][id] == 0){
			g_hasHyperPotion[id] = false
			g_hasNoItems[id] = true
		}
		if(get_user_health(id) <= maxhp[id] - 200) set_user_health(id, get_user_health(id) + 200)
		else set_user_health(id, maxhp[id])
		client_print(id,print_chat,"[PokeMod] You used a Hyper Potion!")
	}
	else if(g_hasFullRestore[id]){
		emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		Item[6][id] -= 1
		if(Item[6][id] == 0){
			g_hasFullRestore[id] = false
			g_hasNoItems[id] = true
		}
		g_isPoisoned[id] = false
		g_isAsleep[id] = false
		screenflash(id, 0, 0, 0, 0)
		g_isLeeched[id] = false
		set_user_health(id, maxhp[id])
		client_print(id,print_chat,"[PokeMod] You used a Full Restore!")
	}
	else if(g_hasBicycle[id]){
		client_print(id,print_chat,"[PokeMod] You are already riding your bicycle!")
	}
	else if(g_hasHPUp[id]){
		emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		Item[8][id] -= 1
		if(Item[8][id] == 0){
			g_hasHPUp[id] = false
			g_hasNoItems[id] = true
		}
		maxhp[id] += 100
		set_user_health(id, get_user_health(id) + 100)
		client_print(id,print_chat,"[PokeMod] You used a HP Up!")
	}
	else sounddeny(id)

	return PLUGIN_HANDLED
 }
 public EscapeRope(id)
 {
	new entSpawn
	new Float:spawnAngle[3] 
	new Float:spawnOrigin[3]

	for(new i=0 ; i < 33 ; i++){
		spawnPointsused[i] = false
	}

	if(get_user_team(id)==1)
		entSpawn = find_free_spawn(id, 1, spawnOrigin, spawnAngle)
	else 
		entSpawn = find_free_spawn(id, 2, spawnOrigin, spawnAngle)

	if (!entSpawn) 
	{ 
		// Didn't find a free spawn spot. Quit... 
		client_print(id,print_chat,"[PokeMod] You couldn't find a way out.")
		return PLUGIN_CONTINUE 
	}

	new origin[3]

	FVecIVec(spawnOrigin, origin)

	entity_set_vector(id, EV_VEC_angles, spawnAngle)
	set_user_origin(id,origin)

	return PLUGIN_HANDLED
 }

 //--The pokemon skills that require pressing a key--//
 public Squirtle_keydown(id, tog)
 {
	if (!BindUsed[id]){
		if ( entity_get_int(id, EV_INT_waterlevel) == 3 ) bubbles[id] = get_cvar_num("pm_bubblenum")
		BindUsed[id] = true
		if(bubbles[id] > 0){

			new num, abody, aid, vec[3], aimvec[3]
			get_user_origin(id, vec)
			get_user_origin(id, aimvec, 2)
			num = get_distance(vec, aimvec)/15
			get_user_aiming(id, aid, abody)

			emit_sound(id, CHAN_WEAPON, "player/pl_swim3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			if ( entity_get_int(id, EV_INT_waterlevel) != 3 ){
				bubbles[id] -= 1
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)	//message begin
				write_byte(15)
				write_coord(vec[0])		// start position
				write_coord(vec[1])
				write_coord(vec[2])
				write_coord(aimvec[0])	// end position
				write_coord(aimvec[1])
				write_coord(aimvec[2])
				write_short(bubble)		// sprite index
				write_byte(num)		// count
				write_byte(1/2)		// life in 0.1's
				write_byte(3)		// scale in 0.1's
				write_byte(5)		// velocity along vector in 10's
				write_byte(5)	// randomness of velocity in 10's
				message_end()
			}
			else {
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
				write_byte(114)
				write_coord(vec[0])			// min start position
				write_coord(vec[1])
				write_coord(vec[2])
				write_coord(aimvec[0])		//  max start position
				write_coord(aimvec[1])
				write_coord(aimvec[2])
				write_coord(EV_INT_waterlevel)	// float height
				write_short(bubble)			// model index
				write_byte(2*num)			// count
				write_coord(100)			// speed
				message_end()
			}

			set_task(1.0 , "bind_status", id )

			set_hudmessage(0, 0, 255, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
			show_hudmessage(id, "You have %d Bubble Beams", bubbles[id])

			if ( aid > 0 && aid <= 32 && is_user_alive(aid)){
				new ta
				if(aid==id) ta = 2
				else if(get_user_team(id) == get_user_team(aid)) ta = 1
				else ta = 0
				fdamage(aid, id, get_cvar_num("pm_bubbledamage"), 0, ta)
				emit_sound(aid, CHAN_AUTO, "player/pl_pain7.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
			}
		}
		else {
			client_print(id, print_chat, "[PokeMod] You are out of Bubble Beam, go into water and keydown.")
			sounddeny(id)
		}
	}
	else sounddeny(id)
	if(tog == 1) g_hasSquirtle[id] = false
 }
 public Bulbasaur_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return
	}
	new abody, aid, parm[2]
	parm[0] = id
	get_user_aiming(id, aid, abody)
	g_isSearching[id] = true

	if ( aid > 0 && aid <= 32 && is_user_alive(aid) ){
		if (!g_isLeeched[aid]){
			g_isLeeched[aid] = true
			parm[1] = aid
			g_isSearching[id] = false
			set_task(0.1, "bulbasaur_loop",1, parm, 2)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		else client_print(id, print_chat, "[PokeMod] The enemy is already being leeched and is not effected!")
	}
	if(g_isSearching[id] && !BindUsed[id] && count[id] > 0 && is_user_alive(id)){
		count[id] -= 1
		set_task(0.1,"Bulbasaur_keydown", id)
		emit_sound(id,CHAN_ITEM, "turret/tu_ping.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		set_task(get_cvar_float("pm_time"),"bulbasaur_stop", id)
	}
	if(tog==1) g_hasBulbasaur[id] = false
 }
 public bulbasaur_stop(id)
 {
	if(g_isSearching[id] && !BindUsed[id]){
		set_task(get_cvar_float("pm_time"), "bind_status", id )
		g_isSearching[id] = false
		BindUsed[id] = true
		count[id] = 20*get_cvar_num("pm_time")
	}
 }
 public bulbasaur_loop(parm[])
 {
	new id = parm[0], aid = parm[1], origin[3], aorigin[3]
	if(!is_user_alive(id)||!is_user_alive(aid)) return

	new aName[32], iName[32]
	get_user_origin(id, origin)
	get_user_origin(aid, aorigin)

	emit_sound(id, CHAN_AUTO, "hornet/ag_hornethit1.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	emit_sound(aid, CHAN_AUTO, "hornet/ag_hornethit1.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(8)		// TE_BEAMENTS
	write_short(id)		// Start Entity
	write_short(aid)		// End Entity
	write_short(rope)		// Sprite Index
	write_byte(1)		// Starting Frame
	write_byte(1)		// Frame Rate in 0.1's
	write_byte(10)		// Life in 0.1's
	write_byte(5)		// Line width in 0.1's
	write_byte(0)		// Noise amplitude in 0.01's
	write_byte(0)		// Red
	write_byte(255)		// Green
	write_byte(0)		// Blue
	write_byte(100)		// Brightness
	write_byte(0)		// Scroll speed in 0.1's
	message_end()

	get_user_name(id, iName, 31)
	get_user_name(aid, aName, 31)

	set_hudmessage(0, 255, 0, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(id, "You have leeched %s", aName)
	set_hudmessage(0, 255, 0, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(aid, "You have been leeched by %s", iName)

	screenflash(id, 0, 255, 0, 50)
	screenflash(aid, 0, 255, 0, 50)

	if(get_user_health(id)<100) set_user_health(id, get_user_health(id) + get_cvar_num("pm_leech"))

	fdamage(aid, id, get_cvar_num("pm_leech"), 1,0)

	if( is_user_alive(id) && is_user_alive(aid) && g_isLeeched[aid]) set_task(5.0, "bulbasaur_loop",1, parm, 2)
	else g_isLeeched[aid] = false
 }
 public Geodude_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return PLUGIN_HANDLED
	}
	BindUsed[id] = true
	new harden, armor = get_user_armor(id), ammount = get_cvar_num("pm_harden")
	harden = ammount * armor / 2
	set_user_health(id, get_user_health(id) + harden)
	set_user_armor(id, get_user_armor(id) / 2)
	if(tog == 1) g_hasGeodude[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
	return PLUGIN_HANDLED
 }
 public Onix_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return PLUGIN_HANDLED
	}
	BindUsed[id] = true
	new Float: origin[3], Float: aim[3], Float: velocity[3], Ent

	entity_get_vector(id, EV_VEC_origin, origin)
	entity_get_vector(id, EV_VEC_v_angle, aim)
	origin[2] += 20

	Ent = create_entity("info_target")

	if (!Ent) return PLUGIN_HANDLED

	entity_set_string(Ent, EV_SZ_classname, "boulder")
	entity_set_model(Ent, "models/big_rock.mdl")

	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	entity_set_vector(Ent, EV_VEC_mins, MinBox)
	entity_set_vector(Ent, EV_VEC_maxs, MaxBox)

	entity_set_origin(Ent, origin)
	entity_set_vector(Ent, EV_VEC_angles, aim)

	entity_set_int(Ent, EV_INT_effects, 2)
	entity_set_int(Ent, EV_INT_solid, 1)
	entity_set_int(Ent, EV_INT_movetype, 10)
	entity_set_edict(Ent, EV_ENT_owner, id)

	VelocityByAim(id, 2000 , velocity)
	entity_set_vector(Ent, EV_VEC_velocity, velocity)

	emit_sound(id,CHAN_VOICE,"turret/tu_fire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	if(tog == 1) g_hasOnix[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
	return PLUGIN_HANDLED
 }

 public Diglet_keydown(id, tog)
 {
	if(BindUsed[id] || g_isDigging[id]){
	sounddeny(id)
	return PLUGIN_HANDLED
	}
	new parm[7]
	get_user_origin(id, origin[id])
	get_user_origin(id, aim[id], 3)
	parm[0] = origin[id][0]
	parm[1] = origin[id][1]
	parm[2] = origin[id][2]
	parm[3] = aim[id][0]
	parm[4] = aim[id][1]
	parm[5] = aim[id][2]
	parm[6] = id
	ctime[id] = 70 //1 sec going down/up
	if (PassTest(id)){
	set_task(0.1, "Dig",6, parm, 7)
	g_isDigging[id] = true
	BindUsed[id] = true
	if(tog == 1) g_hasDiglet[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
	}
	return PLUGIN_HANDLED
 }
 PassTest(id)
 {
	new origin[3], clip, ammo, Float:Orig[3], wpnid = get_user_weapon(id, clip, ammo)
	get_user_origin(id, origin, 3)
	Orig[0]=float(origin[0])
	Orig[1]=float(origin[1])
	Orig[2]=float(origin[2])
	new AimAt = PointContents(Orig)
	if (AimAt == CONTENTS_SKY) {
		client_print(id,print_chat,"[PokeMod] You cannot dig to the sky.")
		return false
	}
	if(wpnid == CSW_C4){
		client_print(id,print_chat,"[PokeMod] You cannot dig while holding a c4.")
		return false
	}
	return true
 }
 public Dig(parm[])
 {
	new id=parm[6], multi1, multi2, multi31, multi32

	multi1 = (parm[0]-parm[3]) / 50
	multi2 = (parm[1]-parm[4]) / 50

	if(parm[2] < 0) multi31 = (parm[2]-1000) / 10
	else multi31 = (-1*parm[2]-1000) / 10
	if(parm[5] < 0) multi32 = (parm[5]-1000) / 10
	else multi32 = (-1*parm[5]-1000) / 10

	if(ctime[id]>60){ //Move down
		new origin[3]
		get_user_origin(id, origin)
		if(multi31 < 0) origin[2] -= (-1*multi31)
		else origin[2] -= (multi31)
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]>10 && ctime[id]<=60){
		new origin[3]
		get_user_origin(id, origin)
		origin[0] -= multi1
		origin[1] -= multi2
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]<=10){ //Move up
		new origin[3]
		get_user_origin(id, origin)
		if(multi32 < 0) origin[2] += (-1*multi32)
		else origin[2] += (multi32)
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]==0){
		g_isDigging[id] = false
		checkCount[id] = 1
		positionChangeTimer(id)
	}
	if(ctime[id]>0 && g_isDigging[id]) set_task(0.1, "Dig",6, parm, 7)
 }
 public positionChangeTimer(id)
 {
	if (!is_user_alive(id)) return

	new Float:velocity[3]
	get_user_origin(id, g_lastPosition[id])

	entity_get_vector(id, EV_VEC_velocity, velocity)
	if ( velocity[0]==0.0 && velocity[1]==0.0 ) {
		// Force a Move (small jump)
		velocity[0] += 20.0
		velocity[2] += 50.0
		entity_set_vector(id, EV_VEC_velocity, velocity)
	}

	set_task(0.2,"positionChangeCheck",id)
 }
 public positionChangeCheck(id)
 {
	if (!is_user_alive(id)) return

	new origin[3]
	get_user_origin(id, origin)

	if ( g_lastPosition[id][0] == origin[0] && g_lastPosition[id][1] == origin[1] && g_lastPosition[id][2] == origin[2]) {
		switch(checkCount[id]) {
			case 0 : movecheck(id, 0, 0, 0)	// Original
			case 1 : movecheck(id, 0, 0, 80)	// Up
			case 2 : movecheck(id, 0, 0, -110)	// Down
			case 3 : movecheck(id, 0, 30, 0)	// Forward
			case 4 : movecheck(id, 0, -30, 0)	// Back
			case 5 : movecheck(id, -30, 0, 0)	// Left
			case 6 : movecheck(id, 30, 0, 0)	// Right
			case 7 : movecheck(id, -30, 30, 0)	// Forward-Left
			case 8 : movecheck(id, 30, 30, 0)	// Forward-Right
			case 9 : movecheck(id, -30, -30, 0)	// Back-Left
			case 10: movecheck(id, 30, -30, 0)	// Back-Right
			case 11: movecheck(id, 0, 30, 60)	// Up-Forward
			case 12: movecheck(id, 0, 30, -110)	// Down-Forward
			case 13: movecheck(id, 0, -30, 60)	// Up-Back
			case 14: movecheck(id, 0, -30, -110)	// Down-Back
			case 15: movecheck(id, -30, 0, 60)	// Up-Left
			case 16: movecheck(id, 30, 0, 60)	// Up-Right
			case 17: movecheck(id, -30, 0, -110)	// Down-Left
			case 18: movecheck(id, 30, 0, -110)	// Down-Right
			default: user_kill(id)
		}
		return
	}
 }
 public movecheck(id, mX, mY, mZ)
 {
	new Spot[33][3]
	Spot[id][0] = aim[id][0] + mX
	Spot[id][1] = aim[id][1] + mY
	Spot[id][2] = aim[id][2] + mZ
	set_user_origin(id,Spot[id])
	checkCount[id]++
	positionChangeTimer(id)
 }
 public Starmie_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return
	}
	BindUsed[id] = true
	emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	screenflash(id, 128, 0, 128, 50)
	set_user_health(id, get_user_health(id) + (maxhp[id]-get_user_health(id))/4)
	if(tog == 1) g_hasStarmie[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
 }
 public Poliwhirl_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return
	}
	emit_sound(id, CHAN_WEAPON, "pokemon/cast.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	BindUsed[id] = true
	screenflash(id, 0, 0, 255, 50)
	get_user_origin(id, origin[id])
	for (new aid = 0; aid <= 32; aid++) {
		if( is_user_alive(aid) && get_user_team(id) != get_user_team(aid)) {
			get_user_origin(aid, origin[aid])

			new distance = get_distance(origin[aid], origin[id])
			if(distance <= 500){
				new ran = random_num(1,180), Float:look[3]
			
				entity_get_vector(aid, EV_VEC_angles, look)
				if(look[0]<180) look[0] +=ran
				else look[0] -= ran
				if(look[1]<180) look[1] +=ran
				else look[1] -= ran

				entity_set_vector(aid, EV_VEC_angles, look)
				entity_set_int(aid, EV_INT_fixangle, 1) 
			}
		}
	}
	if(tog == 1) g_hasPoliwhirl[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
 }
 public Togepi_keydown(id)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return
	}
	screenflash(id, 248, 201, 74, 50)
	new ran = random_num(1,8)
	switch(ran)
	{
		case 1:{
			g_hasSquirtle[id] = true
			Squirtle_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 2:{
			g_hasBulbasaur[id] = true
			Bulbasaur_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 3:{
			g_hasGeodude[id] = true
			Geodude_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 4:{
			g_hasOnix[id] = true
			Onix_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 5:{
			g_hasDiglet[id] = true
			Diglet_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 6:{
			g_hasStarmie[id] = true
			Starmie_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 7:{
			g_hasPoliwhirl[id] = true
			Poliwhirl_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
		case 8:{
			g_hasHaunter[id] = true
			Haunter_keydown(id, 1)
			set_task(get_cvar_float("pm_time"), "bind_status", id )
		}
	}
 }
 public Haunter_keydown(id, tog)
 {
	if(BindUsed[id]){
	sounddeny(id)
	return
	}
	new body, aid, ta
	get_user_aiming(id, aid, body)
	if(!is_user_alive(aid)) return
	if(aid==id) ta = 2
	else if(get_user_team(id) == get_user_team(aid)) ta = 1
	else ta = 0
	if(!g_isAsleep[aid]){
	emit_sound(id, CHAN_WEAPON, "pokemon/cast.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	g_isAsleep[aid] = true
	set_task(0.1, "hsleep", aid)
	set_task(5.0, "unsleep", aid)
	set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(id, "They are now asleep")
	set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(aid, "You have been put to sleep")
	}
	else {//dream eat
	emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	BindUsed[id] = true
	fdamage( aid, id, 33, 3, ta)
	set_user_health(id, get_user_health(id) + 33)
	set_task(1.0, "unsleep", aid)
	set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(id, "You ate their dream")
	set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(aid, "Your dream has been eaten")
	}
	if(tog == 1) g_hasHaunter[id] = false
	else set_task(get_cvar_float("pm_time"), "bind_status", id )
 }

 //--Pokemon skills that have to do with being damaged or giving damage--//
 public pokemon_damage(id)
 {
	if (get_cvar_num("pm_pokemod")==1 && is_user_alive(id))
	{
		new damage = read_data(2)
		if(g_hasCharmander[id])
		{
			new ragenums

			ragenums = damage / get_cvar_num("pm_rage")
			rage[id] += ragenums

			set_hudmessage(255, 0, 0, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
			show_hudmessage(id, "Your rage is at %d extra damage", rage[id])
		}

		new body, ta, weapon, aid = get_user_attacker(id, weapon, body), rand = random_num(1,10)

		if ( aid > 0 && aid <= 32 && is_user_alive(aid) && aid != id ) {
			if(aid==id) ta = 2
			else if(get_user_team(id) == get_user_team(aid)) ta = 1
			else ta = 0
			if (g_hasCharmander[aid] && rage[aid] > 0){
				fdamage( id, aid, rage[aid], 5, ta)
				set_hudmessage(255, 0, 0, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "Your rage did %d extra damage", rage[aid])
			}
			if(g_hasPikachu[aid]){
				if(rand<4){
				fdamage( id, aid, damage, 6, ta)
				set_hudmessage(250, 250, 10, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You did double damage with quick attack")
				}
				else{
				set_hudmessage(250, 250, 10, 0.05, -0.60, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You missed your second attack")
				}
			}
			if(g_hasGeodude[id]){
				set_user_armor(id, get_user_armor(id) + damage)
			}
			if(g_hasMeowth[id] && rand < 8){
				new parm[3], clip, ammo
				parm[0] = aid
				parm[1] = id
				parm[2] = get_user_weapon(aid, clip, ammo)
				engclient_cmd(aid,"weapon_knife")
				set_hudmessage(248, 201, 74, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(id, "You scratched an enemy")
				set_hudmessage(248, 201, 74, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You have been scratched")
				set_task(0.1, "Scratch",2, parm, 3)
			}
			if(g_hasArbok[id] && !g_isPoisoned[aid] && rand < 6){
				new parm[2]
				parm[0] = aid
				parm[1] = id
				cpois[aid] = get_cvar_num("pm_time")
				g_isPoisoned[aid] = true
				set_hudmessage(128, 0, 128, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(id, "You poisoned an enemy")
				set_hudmessage(128, 0, 128, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You have been poisoned")

				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
				write_byte(8)		// TE_BEAMENTS
				write_short(id)		// Start Entity
				write_short(aid)	// End Entity
				write_short(arbok)		// Sprite Index
				write_byte(1)		// Starting Frame
				write_byte(1)		// Frame Rate in 0.1's
				write_byte(5)		// Life in 0.1's
				write_byte(20)		// Line width in 0.1's
				write_byte(0)		// Noise amplitude in 0.01's
				write_byte(150)		// Red
				write_byte(0)		// Green
				write_byte(150)		// Blue
				write_byte(100)		// Brightness
				write_byte(1)		// Scroll speed in 0.1's
				message_end()

				set_task(0.1, "Poison",1, parm, 2)
			}
		}
	}
 }
 
 //--This is a loop that is being called every second, some pokemon skills use this--//
 public pokemon_loop()
 {
	new players[32], count, id
	get_players(players, count, "ac")

	for ( new x = 0; x < count; x++ )
	{
		id = players[x]

		if(is_user_alive(id) && get_cvar_num("pm_pokemod")==1){

			if(!is_user_bot(id)) PokeDisplay(id)

			if(g_hasBicycle[id]) set_user_maxspeed(id, 400.0)

			if(g_isHealing[id]) set_user_maxspeed(id, 1.0)

			if(g_hasWeezing[id]){
				get_user_origin(id, origin[id])
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
				write_byte(17)
				write_coord(origin[id][0]) // start position
				write_coord(origin[id][1])
				write_coord(origin[id][2])
				write_short(gas) // sprite index
				write_byte(10) // scale in 0.1's
				write_byte(50) // brightness
				message_end() 

				for (new aid = 0; aid <= 32; aid++) {
					if( is_user_alive(aid) && get_user_team(id) != get_user_team(aid) && !g_isPoisoned[aid]) {
					get_user_origin(aid, origin[aid])

					new distance = get_distance(origin[aid], origin[id])
					if(distance <= 300){
						new parm[2]
						parm[0] = aid
						parm[1] = id
						cpois[aid] = get_cvar_num("pm_time") / 2
						g_isPoisoned[aid] = true
						set_hudmessage(128, 0, 128, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
						show_hudmessage(id, "You poisoned an enemy")
						set_hudmessage(128, 0, 128, 0.05, -0.30, 1, 0.1, 2.0, 0.1, 0.1, 80)
						show_hudmessage(aid, "You have been poisoned")

						set_task(0.1, "Poison",1, parm, 2)
						}
					}
				}
			}
			else if(g_hasGengar[id]){
				new rand = random_num(1,8), rand2 = random_num(1,8), numb, numb2
				if(rand == 1 && rand2!=1) numb = 1
				else if(rand == 2 && rand2!=2) numb = 2
				else if(rand == 3 && rand2!=3) numb = 4
				else if(rand == 4 && rand2!=4) numb = 8
				else if(rand == 5 && rand2!=5) numb = 16
				else if(rand == 6 && rand2!=6) numb = 32
				else if(rand == 7 && rand2!=7) numb = 64
				else if(rand == 8 && rand2!=8) numb = 128
				else numb = 0
				if(rand2 == 1) numb2 = 1
				else if(rand2 == 2) numb2 = 2
				else if(rand2 == 3) numb2 = 4
				else if(rand2 == 4) numb2 = 8
				else if(rand2 == 5) numb2 = 16
				else if(rand2 == 6) numb2 = 32
				else if(rand2 == 7) numb2 = 64
				else if(rand2 == 8) numb2 = 128
				set_user_hitzones(0,id,(255-numb)-numb2)
			}
			else if(g_hasGastly[id]){
				gtime += 1
				if(gtime==20)gtime = 0
				switch(gtime){
					case 0: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 200)
					case 1,19: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 175)
					case 2,18: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 150)
					case 3,17: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 125)
					case 4,16: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 100)
					case 5,15: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 75)
					case 6,14: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 50)
					case 7,13: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 25)
					case 8,9,11,12: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 10)
					case 10: set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 0)
				}
			}
			if(is_user_bot(id)){
				new hp = get_user_health(id), numb = random_num(1,10)
				if(g_isPoisoned[id] && (g_hasAntidote[id] || g_hasFullHeal[id] || g_hasFullRestore[id] ))
					UseItem(id)
				if(g_isAsleep[id] && ( g_hasFullHeal[id] || g_hasFullRestore[id] ))
					UseItem(id)
				if(g_isLeeched[id] && ( g_hasFullHeal[id] || g_hasFullRestore[id] ))
					UseItem(id)
				if(g_hasPotion[id] && hp < 80 && numb < 3)
					UseItem(id)
				if(g_hasSuperPotion[id] && hp < 50 && numb < 3)
					UseItem(id)
				if(g_hasHyperPotion[id] && hp < 25 && numb < 3)
					UseItem(id)
				if(g_hasEscapeRope[id] && hp < 50 && numb < 3)
					UseItem(id)
				if(g_hasHPUp[id])
					UseItem(id)
			}
		}
	}
 }

 //--Fake damage--//
 fdamage(victim, attacker, damage, skill, tk)
 {
	new namek[32],namev[32],authida[35],authidv[35],teama[32],teamv[32], Attack[13]
	get_user_name(victim,namev,31)
	get_user_name(attacker,namek,31)
	get_user_authid(victim,authidv,34)
	get_user_authid(attacker,authida,34)
	get_user_team(victim,teamv,31)
	get_user_team(attacker,teama,31)
	
	//0=BB,1=LS,2=RT,3=DE,4=P,5=R,6=QA
	if(skill==0) Attack = "Bubble Beam"
	else if(skill==1) Attack = "Leech Seed"
	else if(skill==2) Attack = "Rock Throw"
	else if(skill==3) Attack = "Dream Eater"
	else if(skill==4) Attack = "Poison"
	else if(skill==5) Attack = "Rage"
	else if(skill==6) Attack = "Quick Attack"

	new Float:fl_dmg = float(damage)

	if(damage >= get_user_health(victim))
	{
		set_msg_block(get_user_msgid("DeathMsg"),BLOCK_SET)
		if(get_user_team(victim) == get_user_team(attacker) && tk == 1 && get_cvar_num("mp_friendlyfire")==1)
		{
			fakedamage(victim, Attack, fl_dmg, DMG_GENERIC)
		}
		else if(tk!=1 && (get_user_team(attacker)!=get_user_team(victim) || attacker==victim) )
		{
			fakedamage(victim, Attack, fl_dmg, DMG_GENERIC)
		}
		set_msg_block(get_user_msgid("DeathMsg"),BLOCK_NOT)

		if(is_user_alive(victim))
		return

		message_begin(MSG_ALL, get_user_msgid("DeathMsg"), {0,0,0}, 0)
		write_byte(attacker)
		write_byte(victim)
		write_byte(0)
		write_string(Attack)
		message_end()

		if(tk == 1 && get_cvar_num("mp_friendlyfire")==1)
		{
			client_print(attacker,print_center,"You killed a teammate")
			set_user_frags(attacker,get_user_frags(attacker) - 1 )
			set_user_frags(victim, get_user_frags(victim) + 1)
			log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with %s",
			namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv,Attack)
		}
		else if(tk == 2)
		{
			log_message("^"%s<%d><%s><%s>^" killed self with %s",
			namek,get_user_userid(attacker),authida,teama,Attack)
		}
		else
		{
			new money = cs_get_user_money(attacker)
			cs_set_user_money(attacker, money + 300) // award for kill

			set_user_frags(attacker,get_user_frags(attacker) + 1 )
			log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with %s",
			namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(victim),authidv,teamv,Attack)
		}
	}
	else
	{
		if(get_user_team(victim) == get_user_team(attacker) && tk == 1 && get_cvar_num("mp_friendlyfire")==1)
		{
			fakedamage(victim, Attack, fl_dmg, DMG_GENERIC)
			client_print(0,print_chat,"%s attacked a teammate",namek)
		}
		else if(tk!=1 && (get_user_team(attacker)!=get_user_team(victim) || attacker==victim) )
		{
			fakedamage(victim, Attack, fl_dmg, DMG_GENERIC)
		}
	}
 }
 
 //--When something touches another--//
 public pfn_touch(ptr, ptd)
 {
	if(get_cvar_num("pm_pokemod")!=1) return
	if (ptr <= 0) return
	if (!is_valid_ent(ptr)) return
	
	new szClass[32]
	entity_get_string(ptr, EV_SZ_classname, szClass, 31)

	if(equal(szClass, "npc_pokecenter") && 0<ptd<33){
		PokeMenu(ptd)
		if(is_user_bot(ptd)) BotCenter(ptd)
	}
	if(equal(szClass, "boulder"))
	{
		new damradius = 200
		new maxdamage = get_cvar_num("pm_rockthrow")

		new Float:fl_vExplodeAt[3]
		entity_get_vector(ptr, EV_VEC_origin, fl_vExplodeAt)
		new vExplodeAt[3]
		vExplodeAt[0] = floatround(fl_vExplodeAt[0])
		vExplodeAt[1] = floatround(fl_vExplodeAt[1])
		vExplodeAt[2] = floatround(fl_vExplodeAt[2])
		
		new aid = entity_get_edict(ptr, EV_ENT_owner)
		
		new origin[3],dist,id,Float:dRatio,rockdamage

		for ( id = 0; id < 32; id++)
		{
			if(is_user_alive(id))
			{
				get_user_origin(id,origin)
				dist = get_distance(origin,vExplodeAt)
				if (dist <= damradius)
				{
					new ta
					dRatio = floatdiv(float(dist),float(damradius))
					rockdamage = maxdamage - floatround(floatmul(float(maxdamage),dRatio))
					if(aid == id) ta = 2
					else if( get_user_team(aid) != get_user_team(id) ) ta = 0
					else ta = 1
					fdamage(id, aid, rockdamage, 2, ta)
				}
			}
		}

		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(17)
		write_coord(vExplodeAt[0])
		write_coord(vExplodeAt[1])
		write_coord(vExplodeAt[2] + 60)
		write_short(xplode)
		write_byte(20)
		write_byte(200)
		message_end()

		emit_sound(ptr, CHAN_WEAPON, "pokemon/a_exm2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

		remove_entity(ptr)
	}
	if(equal(szClass,"item") && 0<ptd<33)
	{
		new id = entity_get_edict(ptr,EV_ENT_owner)

		if(!is_user_connected(id)) return

		if(find_ent_by_owner(-1,"item",id)!=0){
			remove_entity(find_ent_by_owner(-1,"item",id))
		}

		remove_task(3331+id)
		Give_Item(ptd, id)
		
		emit_sound(ptd,CHAN_VOICE,"common/bodydrop1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
   	}
 }

 //--Sleeping Things--//
 public hsleep(id)
 {
 	if(g_isAsleep[id]){
		screenflash(id, 0, 0, 0, 255)
		set_task(0.1, "hsleep", id)
	}
 }
 public unsleep(id)
 {
	if(g_isAsleep[id]){
		screenflash(id, 0, 0, 0, 0)
		g_isAsleep[id] = false
		set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
		show_hudmessage(id, "You have woken up")
	}
 }
 
 //--Poison--//
 public Poison(parm[])
 {
	new id = parm[1], aid = parm[0]

	if(g_isPoisoned[aid] && cpois[aid] > 0 && is_user_alive(id) && is_user_alive(aid)){
	cpois[aid] -= 1
	screenflash(id, 128, 0, 128, 50)
	screenflash(aid, 128, 0, 128, 50)
	fdamage( aid, id, get_cvar_num("pm_poison"), 4, 0)
	emit_sound(aid, CHAN_AUTO, "player/pl_pain7.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	set_task(1.0, "Poison",1, parm, 2)
	}
	else g_isPoisoned[aid] = false
 }
 
 //--Switches weapons back--//
 public Scratch(parm[])
 {
	new weaponName[32]
	screenflash(parm[0], 248, 201, 74, 50)
	screenflash(parm[1], 248, 201, 74, 50)
	get_weaponname(parm[2],weaponName,31)
	engclient_cmd(parm[0], weaponName )
 }

 //--Resets whether a user can use their pokemon bind--//
 public bind_status(id)
 {
	if(BindUsed[id]) BindUsed[id] = false
 }
 
 //--Saves users pokemon--//
 public savepokemon(id)
 {
	if(save[id]){
		client_print(id,print_chat,"[PokeMod] Your pokemon is no longer saved.")
		save[id] = false
	}
	else {
		client_print(id,print_chat,"[PokeMod] Your pokemon is now saved.")
		save[id] = true
	}

	return PLUGIN_HANDLED
 }
 
 //--Finishes the pokecenter heal--//
 public finish_heal(id)
 {
	if(get_cvar_num("pm_pokemod")!=1 || !is_user_alive(id)) return

	new Float:dist, parm[3], clip, ammo

	dist = Float:entity_range(id,PCent[1])
	if(dist>200) dist = Float:entity_range(id,PCent[2])

	if(dist<201){
		client_print(id, print_chat, "[PokeMod] You are fully healed.")
		set_user_maxspeed(id, get_user_maxspeed(id))
		set_user_health(id, maxhp[id])
	}
	else {
		client_print(id, print_chat, "[PokeMod] You are too far away to be healed.")
		set_user_maxspeed(id, get_user_maxspeed(id))
	}
	
	g_isHealing[id] = false
	
	//Make them able to move again
	parm[0] = id
	parm[1] = id
	parm[2] = get_user_weapon(id, clip, ammo)
	engclient_cmd(id,"weapon_knife")
	set_task(0.1, "Scratch",2, parm, 3)
 }
 
 //--Shows user what they have--//
 public PokeDisplay(id)
 {
	if ( get_cvar_num("pm_pokemod")!=1 || !is_user_connected(id) ) return

	new message[256],pokemon[11],item[13], iLen, inum

	if(get_user_health(id) > 255) iLen = format(message, (255), " HP: %d/%d", get_user_health(id), maxhp[id])

	if(g_hasSelected[id]){
		if(g_hasCharmander[id])			pokemon = "Charmander"
		else if (g_hasBulbasaur[id])	pokemon = "Bulbasaur"
		else if (g_hasSquirtle[id])		pokemon = "Squirtle"
		else if (g_hasPikachu[id])		pokemon = "Pikachu"
		else if (g_hasOnix[id])			pokemon = "Onix"
		else if (g_hasGeodude[id])		pokemon = "Geodude"
		else if (g_hasDiglet[id])		pokemon = "Diglet"
		else if (g_hasStarmie[id])		pokemon = "Starmie"
		else if (g_hasTogepi[id])		pokemon = "Togepi"
		else if (g_hasPoliwhirl[id])	pokemon = "Poliwhirl"
		else if (g_hasArbok[id])		pokemon = "Arbok"
		else if (g_hasWeezing[id])		pokemon = "Weezing"
		else if (g_hasMeowth[id])		pokemon = "Meowth"
		else if (g_hasGastly[id])		pokemon = "Gastly"
		else if (g_hasHaunter[id])		pokemon = "Haunter"
		else if (g_hasGengar[id])		pokemon = "Gengar"
	}

	if(!g_hasNoItems[id]){
		if(g_hasPotion[id]){
			item = "Potion"
			inum = Item[0][id]
		}
		else if (g_hasAntidote[id]){
			item = "Antidote"
			inum = Item[1][id]
		}
		else if (g_hasEscapeRope[id]){
			item = "Escape Rope"
			inum = Item[2][id]
		}
		else if (g_hasFullHeal[id]){
			item = "Full Heal"
			inum = Item[3][id]
		}
		else if (g_hasSuperPotion[id]){
			item = "Super Potion"
			inum = Item[4][id]
		}
		else if (g_hasHyperPotion[id]){
			item = "Hyper Potion"
			inum = Item[5][id]
		}
		else if (g_hasFullRestore[id]){
			item = "Full Restore"
			inum = Item[6][id]
		}
		else if (g_hasBicycle[id]){
			item = "Bicycle"
			inum = Item[7][id]
		}
		else if (g_hasHPUp[id]){
			item = "HP Up"
			inum = Item[8][id]
		}
	}

	if ( !g_hasSelected[id] && g_hasNoItems[id] ) {
		if(get_user_health(id) < 256) iLen += format(message[iLen],(255-iLen),"You do not have a pokemon or pokeitem")
	}
	else if ( g_hasSelected[id] && g_hasNoItems[id] ) {
		iLen += format(message[iLen],(255-iLen)," Pokemon: %s", pokemon )
	}
	else if ( !g_hasSelected[id] && !g_hasNoItems[id] ) {
		iLen += format(message[iLen],(255-iLen)," Pokeitem: %s", item )
	}
	else {
		iLen += format(message[iLen],(255-iLen)," Pokemon: %s  Pokeitem: %s", pokemon, item )
	}
	
	if(inum > 1) iLen += format(message[iLen],(255-iLen)," x %d", inum )

	message_begin( MSG_ONE, get_user_msgid("StatusText"), {0,0,0}, id)
	write_byte(0)
	write_string(message)
	message_end()
 }

 //--Flashes the screen a color--//
 screenflash(id, r, g, b, alpha)
 {
	message_begin(MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id)
	write_short( 1<<10 )
	write_short( 1<<10 )
	write_short( 1<<12 )
	write_byte( r )
	write_byte( g )
	write_byte( b )
	write_byte( alpha )
	message_end()
 }
 
 //--Sound when user cant do something--//
 sounddeny(id)
 {
	client_cmd(id,"spk common/wpn_denyselect.wav")
 }
 
 //--Finds free place to put escape rope users and npcs--//
 stock find_free_spawn(id, iTeamNumber, Float:spawnOrigin[3], Float:spawnAngle[3])
 {
	new iSpawn
	if(iTeamNumber == 2)
		iSpawn=0
	else
		iSpawn=1

	const maxSpawns = 128
	new spawnPoints[maxSpawns]
	new ent = -1, spawnsFound = 0

	/* Find all of the spawn points */
	do {
		ent = find_ent_by_class(ent,spawnEntString[iSpawn])
		if (ent != 0) {
			spawnPoints[spawnsFound] = ent
			spawnsFound++
		}
	}
	while (ent && spawnsFound < maxSpawns)

	new bool:foundFreeSpawn
	new Float:vicinity = 96.0		//(32x32x96)
	new i
	new playersInVicinity
	new entList[1]
	
	/* Loop through all the spawn points */
	for (i = 0;i < spawnsFound && !foundFreeSpawn;i++) 
	{

		if(spawnPoints[i] != 0 && !spawnPointsused[i])
		{
			/* Get the origin of the spawn point */
			entity_get_vector(spawnPoints[i],EV_VEC_origin,spawnOrigin)

			/* Determine if a player is in this vicinity */
			playersInVicinity = find_sphere_class(0, "player", vicinity, entList, 1, spawnOrigin)

			/* If not, we want to transport the player here */
			if (playersInVicinity == 0)
			{
				foundFreeSpawn = true
				spawnPointsused[i] = true
			}
			/* Otherwise we don't */
			else
			{
				foundFreeSpawn = false
			}
		}
		id--
	}

	if( foundFreeSpawn && spawnPoints[i] )
		{
		entity_get_vector(spawnPoints[i], EV_VEC_angles, spawnAngle)
		return spawnPoints[i]
		}

	return -1
 }

 //--Makes NPCs--//
 public npc_pokecenter(team)
 {
	new entSpawn
	new origin[3]
	new Float:spawnAngle[3] 
	new Float:spawnOrigin[3]

	PCent[team] = create_entity("info_target")

	entity_set_string(PCent[team],EV_SZ_classname,"npc_pokecenter");

	entity_set_model(PCent[team],"models/pokemon/oak.mdl");
	entity_set_int(PCent[team],EV_INT_solid, 2)

	new Float:maxs[3] = {13.0,13.0,40.0}
	new Float:mins[3] = {-13.0,-13.0,-40.0}
	entity_set_size(PCent[team],mins,maxs)

	entSpawn = find_free_spawn(PCent[team], team, spawnOrigin, spawnAngle)
		
	if (!entSpawn) 
	{ 
		// Didn't find a free spawn spot. Quit... 
		client_print(0,print_chat,"[PokeMod] A PokeCenter NPC was not created.")
		return PLUGIN_CONTINUE 
	}
		
	FVecIVec(spawnOrigin, origin)

	entity_set_origin(PCent[team],spawnOrigin);
	
	entity_set_vector(PCent[team], EV_VEC_angles, spawnAngle)

	entity_set_byte(PCent[team],EV_BYTE_controller1,125);
	entity_set_byte(PCent[team],EV_BYTE_controller2,125);
	entity_set_byte(PCent[team],EV_BYTE_controller3,125);
	entity_set_byte(PCent[team],EV_BYTE_controller4,125);

	entity_set_float(PCent[team],EV_FL_animtime,2.0)
	entity_set_float(PCent[team],EV_FL_framerate,1.0)
	entity_set_int(PCent[team],EV_INT_sequence,0);

	entity_set_int(PCent[team], EV_INT_movetype, 6)

	drop_to_floor(PCent[team])
	return 1;
 }
 
 //--Gives items to people that touch dropped items--//
 Give_Item(ptd, id)
 {
	if(g_hasPotion[id] && (g_hasPotion[ptd] || g_hasNoItems[ptd]) ){
		g_hasPotion[id] = false
		g_hasPotion[ptd] = true
		g_hasNoItems[ptd] = false
		
		Item[0][ptd] += Item[0][id]
		Item[0][id] = 0

		if(Item[0][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Potions.", Item[0][id])
		if(Item[0][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Potion.")
	}
	else if(g_hasAntidote[id] && (g_hasAntidote[ptd] || g_hasNoItems[ptd]) ){
		g_hasAntidote[id] = false
		g_hasAntidote[ptd] = true
		g_hasNoItems[ptd] = false
		
		Item[1][ptd] += Item[1][id]
		Item[1][id] = 0

		if(Item[1][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Antidotes.", Item[1][id])
		if(Item[1][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up an Antidote.")
	}
	else if(g_hasEscapeRope[id] && (g_hasEscapeRope[ptd] || g_hasNoItems[ptd]) ){
		g_hasEscapeRope[id] = false
		g_hasEscapeRope[ptd] = true
		g_hasNoItems[ptd] = false

		Item[2][ptd] += Item[2][id]
		Item[2][id] = 0
		
		if(Item[2][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Escape Ropes.", Item[2][id])
		if(Item[2][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up an Escape Rope.")
	}
	else if(g_hasFullHeal[id] && (g_hasFullHeal[ptd] || g_hasNoItems[ptd]) ){
		g_hasFullHeal[id] = false
		g_hasFullHeal[ptd] = true
		g_hasNoItems[ptd] = false

		Item[3][ptd] += Item[3][id]
		Item[3][id] = 0
		
		if(Item[3][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Full Heals.", Item[3][id])
		if(Item[3][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Full Heal.")
	}
	else if(g_hasSuperPotion[id] && (g_hasSuperPotion[ptd] || g_hasNoItems[ptd]) ){
		g_hasSuperPotion[id] = false
		g_hasSuperPotion[ptd] = true
		g_hasNoItems[ptd] = false
		
		Item[4][ptd] += Item[4][id]
		Item[4][id] = 0

		if(Item[0][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Super Potions.", Item[4][id])
		if(Item[0][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Super Potion.")
	}
	else if(g_hasHyperPotion[id] && (g_hasHyperPotion[ptd] || g_hasNoItems[ptd]) ){
		g_hasHyperPotion[id] = false
		g_hasHyperPotion[ptd] = true
		g_hasNoItems[ptd] = false

		Item[5][ptd] += Item[5][id]
		Item[5][id] = 0
		
		if(Item[5][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Hyper Potions.", Item[5][id])
		if(Item[5][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Hyper Potion.")
	}
	else if(g_hasFullRestore[id] && (g_hasFullRestore[ptd] || g_hasNoItems[ptd]) ){
		g_hasFullRestore[id] = false
		g_hasFullRestore[ptd] = true
		g_hasNoItems[ptd] = false

		Item[6][ptd] += Item[6][id]
		Item[6][id] = 0
		
		if(Item[6][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d Full Restores.", Item[6][id])
		if(Item[6][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Full Restore.")
	}
	else if(g_hasBicycle[id] && g_hasNoItems[ptd]){
		g_hasBicycle[id] += false
		g_hasBicycle[ptd] = true
		g_hasNoItems[ptd] = false

		Item[7][ptd] += Item[7][id]
		Item[7][id] = 0
		
		if(Item[7][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a Bicycle.")
	}
	else if(g_hasHPUp[id] && (g_hasHPUp[ptd] || g_hasNoItems[ptd]) ){
		g_hasHPUp[id] = false
		g_hasHPUp[ptd] = true
		g_hasNoItems[ptd] = false

		Item[8][ptd] = Item[8][id]
		Item[8][id] = 0
		
		if(Item[8][id]>1) client_print(ptd, print_chat, "[PokeMod] You picked up %d HP Ups.", Item[8][id])
		if(Item[8][id]==1) client_print(ptd, print_chat, "[PokeMod] You picked up a HP Up.")
	}
 }
  
 //--Removes Items--//
 public NoItems(id)
 {
	if(g_hasPotion[id]){
		g_hasPotion[id] = false
		Item[0][id] = 0
	}
	if(g_hasAntidote[id]){
		g_hasAntidote[id] = false
		Item[1][id] = 0
	}
	if(g_hasEscapeRope[id]){
		g_hasEscapeRope[id] = false
		Item[2][id] = 0
	}
	if(g_hasFullHeal[id]){
		g_hasFullHeal[id] = false
		Item[3][id] = 0
	}
	if(g_hasSuperPotion[id]){
		g_hasSuperPotion[id] = false
		Item[4][id] = 0
	}
	if(g_hasHyperPotion[id]){
		g_hasHyperPotion[id] = false
		Item[5][id] = 0
	}
	if(g_hasFullRestore[id]){
		g_hasFullRestore[id] = false
		Item[6][id] = 0
	}
	if(g_hasBicycle[id]){
		g_hasBicycle[id] = false
		Item[7][id] = 0
		set_user_maxspeed(id, get_user_maxspeed(id))
	}
	if(g_hasHPUp[id]){
		g_hasHPUp[id] = false
		Item[8][id] = 0
	}
	g_hasNoItems[id] = true

	return PLUGIN_HANDLED
 }
 //--Sprite for dropped items--//
 public item_sprite(parm[])
 {
	new id = parm[0]

	//TE_SPRITE 
	message_begin(MSG_ALL,SVC_TEMPENTITY) 
	write_byte(17) // additive sprite, plays 1 cycle 
	write_coord(iorigin[id][0]) // pos 
	write_coord(iorigin[id][1]) // pos 
	write_coord(iorigin[id][2]) // pos 
	write_short (pokeball) // spr index     
	write_byte(1) // (scale in 0.1's) 
	write_byte (1000) //(brightness) 
	message_end()
 }

 //--Bot Stuff--//
 BotSay(id, type, num, num2)
 {
	if(get_cvar_num("pm_botsays")!=1) return

	for(new tid = 0; tid<33; tid++){

		if(!is_user_bot(tid) && is_user_connected(tid)){

		new name[32]
		get_user_name(id,name,31)

		if(get_user_team(id) == get_user_team(tid)){
		if(type==1){//bought something

			new item[13]
		
			if(num2==0) item = "Potion"
			else if (num2==1) item = "Antidote"
			else if (num2==2) item = "Escape Rope"
			else if (num2==3) item = "Full Heal"
			else if (num2==4) item = "Super Potion"
			else if (num2==5) item = "Hyper Potion"
			else if (num2==6) item = "Full Restore"
			else if (num2==7) item = "Bicycle"
			else if (num2==8) item = "HP Up"

			if(num==1){//bouhgt 1
				client_print(tid,print_chat,"%s (RADIO): Bought 1 %s.", name, item)
			}
			else if(num==3){//bouhgt 3
				client_print(tid,print_chat,"%s (RADIO): Bought 3 %ss.", name, item)
			}
			else if(num==5){//bouhgt 5
				client_print(tid,print_chat,"%s (RADIO): Bought 5 %ss.", name, item)
			}
		}
		else if(type==2){//chose pokemon

			if(num==1){//charmander
				client_print(tid,print_chat,"%s (RADIO): Chose Charmander.", name)
			}
			else if(num==2){//pikachu
				client_print(tid,print_chat,"%s (RADIO): Chose Pikachu.", name)
			}
			else if(num==3){//geodude
				client_print(tid,print_chat,"%s (RADIO): Chose Geodude.", name)
			}
			else if(num==4){//arbok
				client_print(tid,print_chat,"%s (RADIO): Chose Arbok.", name)
			}
			else if(num==5){//weezing
				client_print(tid,print_chat,"%s (RADIO): Chose Weezing.", name)
			}
			else if(num==6){//meowth
				client_print(tid,print_chat,"%s (RADIO): Chose Meowth.", name)
			}
			else if(num==7){//gastly
				client_print(tid,print_chat,"%s (RADIO): Chose Gastly.", name)
			}
			else if(num==8){//gengar
				client_print(tid,print_chat,"%s (RADIO): Chose Gengar.", name)
			}
		}
		}
		}
	}
 }
 BotCenter(ptd)
 {
	new ran = random_num(1,8)

	if(g_hasSelected[ptd]){
		BotMart(ptd)
		return
	}

	g_hasSelected[ptd] = true

	if(ran==1){
		g_hasCharmander[ptd] = true
		BotSay(ptd, 2, 1, 0)
	}
	if(ran==2){
		g_hasPikachu[ptd] = true
		BotSay(ptd, 2, 2, 0)
	}
	if(ran==3){
		g_hasGeodude[ptd] = true
		BotSay(ptd, 2, 3, 0)
	}
	if(ran==4){
		g_hasArbok[ptd] = true
		BotSay(ptd, 2, 4, 0)
	}
	if(ran==5){
		g_hasWeezing[ptd] = true
		BotSay(ptd, 2, 5, 0)
	}
	if(ran==6){
		g_hasMeowth[ptd] = true
		BotSay(ptd, 2, 6, 0)
	}
	if(ran==7){
		g_hasGastly[ptd] = true
		BotSay(ptd, 2, 7, 0)
	}
	if(ran==8){
		g_hasGengar[ptd] = true
		BotSay(ptd, 2, 8, 0)
	}
 }
 BotMart(ptd)
 {
	new ran = random_num(1,9)
	ShopChoices(ptd, ran)
 }
 